## ns3 3.9

=== nsc-0.5.2/SConstruct ===
# vim: filetype=python

#  Network Simulation Cradle
#  Copyright (C) 2003-2005 Sam Jansen
#
#  This program is free software; you can redistribute it and/or modify it
#  under the terms of the GNU General Public License as published by the Free
#  Software Foundation; either version 2 of the License, or (at your option)
#  any later version.
#
#  This program is distributed in the hope that it will be useful, but WITHOUT
#  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
#  FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
#  more details.
#
#  You should have received a copy of the GNU General Public License along
#  with this program; if not, write to the Free Software Foundation, Inc., 59
#  Temple Place, Suite 330, Boston, MA 02111-1307 USA

# Doesn't work? Had problems using timestamp signatures. Might have sped things
# up...
#SourceSignatures('timestamp')


Help("""
     use 'scons libstackname.so' to built a specific stack.
     use 'scons target=arch' to specify target architecture (either amd64 or x86).
     Default target architecture is autodetect.
     """)

# We use newer SCons versions and naming, need at least 1.0 to build. Scons
# 1.0.1 is included locally, just use "python scons.py".
EnsureSConsVersion(1,0)

def get_target_architecture(context):
    import os
    def get_elf_class(filename):
        file = open(str(filename))
        data = file.read(5)
        file.close()
        # Valid ELF header?
        if data[0] == '\x7f' and data[1] == 'E' and data[2] == 'L' and data[3] == 'F':
            if data[4] == '\x01':
                return 'x86'
            elif data[4] == '\x02':
                return 'amd64'
            raise TypeError, "Unknown ELF class"
        else:
            raise TypeError, "%s: not in ELF format" % filename

    target = ARGUMENTS.get('target')
    # allow user to override using scons target=(amd64|x86)
    if target:
        context.Result('Target set to %s on command line, check skipped' % target)
        context.env['NSC_TARGET_ARCHITECTURE'] = target
        return target
    arch = os.uname()[4]
    context.Message('Checking target architecure...')
    if arch == 'i686' or arch == 'i586' or arch == 'i486' or arch == 'i386':
        result = 'x86'
    elif arch == 'x86_64':
        source = 'int main(void)\n{return 0;}\n'
        context.Message('amd64, checking userland ...')
        result = context.TryCompile(source, '.c')
        if not result:
            return result
        result = get_elf_class(context.lastTarget)
    else:
        raise OSError, ('Unsupported architecture, if you want to '
                        'crosscompile, use \"scons target=x86\" (or amd64)')

    context.Result(result)
    context.env['NSC_TARGET_ARCHITECTURE'] = result
    return result

def filter_globalised(target, source, env):
  """Used by the globaliser builder to remove already globalised files.

  This is required because the suffix for globalised files is still the same as
  the original files (both have .c at the end). We use '.globalised.c' to
  indicate files that have been globalised, so if the source has this string in
  it, we return empty lists to inform SCons that there is no action to be
  taken.
  """
  if len(source) > 1 or len(target) > 1:
    return ([], [])
  if str(source[0]).find('.globalised.') != -1:
    return ([], [])
  env.Depends(target, '#' + env['GLOBALISER'])
  return (target, source)

# -----------------------------------------------------------------------------
# The globaliser action is configured as follows:
#   single_source=True -- This means that if the action is given a list of
#     source files, it will be invoked once for each source file
#   emitter=filter_globalised -- This filtered out alread-globalised files. See
#     the docstring of filter_globalised
#   source_scanner=SourceFileScanner -- Use the default scanner to find
#     dependencies of the source files. This means that the source list will go
#     through the normal C dependency scanning.
globaliser_action = '$CC $CCFLAGS $GLB_CCFLAGS $_CPPDEFFLAGS $_CPPINCFLAGS ' \
    + ' -E $SOURCE -o - | $GLOBALISER $GLB_FLAGS $GLB_LIST >$TARGET'
globaliser_builder = Builder(action=globaliser_action,
                             src_suffix='.c',
                             suffix='.globalised.c',
                             single_source=True,
                             emitter=filter_globalised,
                             source_scanner=SourceFileScanner)

# -----------------------------------------------------------------------------
# Site-local customisation: load a custom.py (if it exists), and allow
# overriding the C and C++ compilers. This allows the user to e.g. specify a
# cross-compiler to compile in 32-bit mode on a 64-bit machine.
vars = Variables('custom.py')
vars.AddVariables(
    ('CC', 'The default C compiler used'),
    ('CXX', 'The default C++ compiler user'),
    ('LINKFLAGS', 'Extra arguments passed to the linker'),
    )

# -----------------------------------------------------------------------------
# Run the configure tests and build the environment
env = Environment(variables=vars)
conf = Configure(env, custom_tests={
      'get_target_architecture': get_target_architecture})
if not conf.get_target_architecture():
    Exit(1)
env = conf.Finish()

# -----------------------------------------------------------------------------
# 'default_env' is exported, it is expected that all SConscript files import
# this environment and Clone it.
default_env = env.Clone(GLOBALISER='globaliser/globaliser', GLB_FLAGS='')
default_env.Append(BUILDERS={'Globaliser': globaliser_builder})
Export('default_env')

# -----------------------------------------------------------------------------
# The list of SConscript files to read in.
SConscript('globaliser/SConscript')

SConscript('freebsd5/SConscript')
SConscript('lwip-HEAD/src/SConscript')
SConscript('openbsd3/SConscript')

SConscript('linux-2.6/SConscript')
SConscript("linux-2.6.18/SConscript")
SConscript("linux-2.6.26/SConscript")

SConscript('test/SConscript')

=== pybindgen-0.15.0/wscript ===
## -*- python -*-
## (C) 2007,2008 Gustavo J. A. M. Carneiro

import Options
import Build

import Scripting
Scripting.excludes.remove('Makefile')
Scripting.dist_format = 'zip'

import Configure
Configure.autoconfig = True

import Logs

#from Params import fatal

import os
import pproc as subprocess
import shutil
import sys
import Configure
import tarfile
import re
import types

import Task
Task.file_deps = Task.extract_deps


APPNAME='pybindgen'
srcdir = '.'
blddir = 'build'



## Add the pybindgen dir to PYTHONPATH, so that the examples and tests are properly built before pybindgen is installed.
if 'PYTHONPATH' in os.environ:
    os.environ['PYTHONPATH'] = os.pathsep.join([os.getcwd(), os.environ['PYTHONPATH']])
else:
    os.environ['PYTHONPATH'] = os.getcwd()


def _get_version_from_bzr_lib(path):
    import bzrlib.tag, bzrlib.branch
    fullpath = os.path.abspath(path)
    if sys.platform == 'win32':
        fullpath = fullpath.replace('\\', '/')
        fullpath = '/' + fullpath
    branch = bzrlib.branch.Branch.open('file://' + fullpath)
    tags = bzrlib.tag.BasicTags(branch)
    #print "Getting version information from bzr branch..."
    history = branch.revision_history()
    history.reverse()
    ## find closest tag
    version = None
    extra_version = []
    for revid in history:
        #print revid
        for tag_name, tag_revid in tags.get_tag_dict().iteritems():
            if tag_revid == revid:
                #print "%s matches tag %s" % (revid, tag_name)
                version = [int(s) for s in tag_name.split('.')]
                ## if the current revision does not match the last
                ## tag, we append current revno to the version
                if tag_revid != branch.last_revision():
                    extra_version = [branch.revno()]
                break
        if version:
            break
    assert version is not None
    _version = version + extra_version
    return _version


def _get_version_from_bzr_command(path):
    # get most recent tag first
    most_recent_tag = None
    proc = subprocess.Popen(['bzr', 'log', '--short'], stdout=subprocess.PIPE)
    reg = re.compile('{([0-9]+)\.([0-9]+)\.([0-9]+)}')
    for line in proc.stdout:
        result = reg.search(line)
        if result is not None:
            most_recent_tag = [int(result.group(1)), int(result.group(2)), int(result.group(3))]
            break
    proc.stdout.close()
    proc.wait()
    assert most_recent_tag is not None
    # get most recent revno
    most_recent_revno = None
    proc = subprocess.Popen(['bzr', 'revno'], stdout=subprocess.PIPE)
    most_recent_revno = int(proc.stdout.read().strip())
    proc.wait()
    version = most_recent_tag + [most_recent_revno]
    return version
    

_version = None
def get_version_from_bzr(path):
    global _version
    if _version is not None:
        return _version
    try:
        import bzrlib.tag, bzrlib.branch
    except ImportError:
        return _get_version_from_bzr_command(path)
    else:
        return _get_version_from_bzr_lib(path)

    
def get_version(path=None):
    if path is None:
        path = srcdir
    try:
        return '.'.join([str(x) for x in get_version_from_bzr(path)])
    except ImportError:
        return 'unknown'

def generate_version_py(force=False, path=None):
    """generates pybindgen/version.py, unless it already exists"""

    filename = os.path.join('pybindgen', 'version.py')
    if not force and os.path.exists(filename):
        return

    if path is None:
        path = srcdir
    version = get_version_from_bzr(path)
    dest = open(filename, 'w')
    if isinstance(version, list):
        dest.write('__version__ = %r\n' % (version,))
        dest.write('"""[major, minor, micro, revno], '
                   'revno omitted in official releases"""\n')
    else:
        dest.write('__version__ = "%s"\n' % (version,))
    dest.close()
    

# http://coreygoldberg.blogspot.com/2009/07/python-zip-directories-recursively.html
def zipper(dir, zip_file, archive_main_folder=None):
    import zipfile
    zip = zipfile.ZipFile(zip_file, 'w', compression=zipfile.ZIP_DEFLATED)
    root_len = len(os.path.abspath(dir))
    for root, dirs, files in os.walk(dir):
        archive_root = os.path.abspath(root)[root_len:]
        for f in files:
            fullpath = os.path.join(root, f)
            archive_name = os.path.join(archive_root, f)
            if archive_main_folder is not None:
                if archive_name.startswith(os.sep):
                    n = archive_name[len(os.sep):]
                else:
                    n = archive_name
                archive_name = os.path.join(archive_main_folder, n)
            zip.write(fullpath, archive_name, zipfile.ZIP_DEFLATED)
    zip.close()


def dist_hook():
    blddir = '../build'
    srcdir = '..'
    version = get_version(srcdir)
    subprocess.Popen([os.path.join(srcdir, "generate-ChangeLog")],  shell=True).wait()
    try:
        os.chmod(os.path.join(srcdir, "ChangeLog"), 0644)
    except OSError:
        pass
    try:
        os.unlink("ChangeLog")
    except OSError:
        pass
    shutil.copy(os.path.join(srcdir, "ChangeLog"), '.')

    ## Write a pybindgen/version.py file containing the project version
    generate_version_py(force=True, path=srcdir)

    ## Copy it to the source dir
    shutil.copy(os.path.join('pybindgen', 'version.py'), os.path.join(srcdir, "pybindgen"))

    ## Package the api docs in a separate tarball
    apidocs = 'apidocs'
    if not os.path.isdir('doc/_build/html'):
        Logs.warn("Not creating docs archive: the `doc/_build/html' directory does not exist")
    else:
        zipper('doc/_build/html', os.path.join("..", "pybindgen-%s-docs.zip" % version))

    # clean up the docs dir
    r = subprocess.Popen(["make", "clean"], cwd='doc').wait()
    if r:
        raise SystemExit(r)

    shutil.rmtree('.shelf', True)

    try:
        os.unlink('waf-light')
    except OSError:
        pass


def set_options(opt):
    opt.tool_options('python')
    opt.tool_options('compiler_cc')
    opt.tool_options('compiler_cxx')
    opt.tool_options('cflags')

    optgrp = opt.add_option_group("PyBindGen Options")

    if os.path.isdir(".bzr"):
        optgrp.add_option('--generate-version',
                          help=('Generate a new pybindgen/version.py file from version control'
                                ' introspection.  Only works from a bzr checkout tree, and is'
                                ' meant to be used by pybindgen developers only.'),
                          action="store_true", default=False,
                          dest='generate_version')

    optgrp.add_option('--examples',
                      help=('Compile the example programs.'),
                      action="store_true", default=False,
                      dest='examples')

    optgrp.add_option('--disable-pygccxml',
                      help=('Disable pygccxml for unit tests / examples.'),
                      action="store_true", default=False,
                      dest='disable_pygccxml')

    optgrp.add_option('--valgrind',
                      help=('Run unit tests through valgrind.'),
                      action="store_true", default=False,
                      dest='valgrind')

def configure(conf):

    def _check_compilation_flag(conf, flag):
        """
        Checks if the C++ compiler accepts a certain compilation flag or flags
        flag: can be a string or a list of strings
        """

        env = conf.env.copy()
        env.append_value('CXXFLAGS', flag)
        try:
            retval = conf.run_c_code(code='#include <stdio.h>\nint main() { return 0; }\n',
                                     env=env, compile_filename='test.cc',
                                     compile_mode='cxx',type='cprogram', execute=False)
        except Configure.ConfigurationError:
            ok = False
        else:
            ok = (retval == 0)
        conf.check_message_custom(flag, 'support', (ok and 'yes' or 'no'))
        return ok

    conf.check_compilation_flag = types.MethodType(_check_compilation_flag, conf)

    ## Write a pybindgen/version.py file containing the project version
    generate_version_py()

    conf.check_tool('command')
    conf.check_tool('python')
    conf.check_python_version((2,3))

    try:
        conf.check_tool('compiler_cc')
        conf.check_tool('compiler_cxx')
    except Configure.ConfigurationError:
        Logs.warn("C/C++ compiler not detected.  Unit tests and examples will not be compiled.")
        conf.env['CXX'] = ''
    else:
        conf.check_tool('cflags')
        conf.check_python_headers()

        if not Options.options.disable_pygccxml:
            gccxml = conf.find_program('gccxml')
            if not gccxml:
                conf.env['ENABLE_PYGCCXML'] = False
            else:
                try:
                    conf.check_python_module('pygccxml')
                except Configure.ConfigurationError:
                    conf.env['ENABLE_PYGCCXML'] = False
                else:
                    conf.env['ENABLE_PYGCCXML'] = True

        # -fvisibility=hidden optimization
        if (conf.env['CXX_NAME'] == 'gcc' and [int(x) for x in conf.env['CC_VERSION']] >= [4,0,0]
            and conf.check_compilation_flag('-fvisibility=hidden')):
            conf.env.append_value('CXXFLAGS_PYEXT', '-fvisibility=hidden')
            conf.env.append_value('CCFLAGS_PYEXT', '-fvisibility=hidden')

        # Add include path for our stdint.h replacement, if needed (pstdint.h)
        if not conf.check(header_name='stdint.h'):
            conf.env.append_value('CPPPATH', os.path.join(conf.curdir, 'include'))

    conf.sub_config('benchmarks')


def build(bld):
    global g_bld
    g_bld = bld
    if getattr(Options.options, 'generate_version', False):
        generate_version_py(force=True)

    bld.add_subdirs('pybindgen')
    if Options.options.examples:
        bld.add_subdirs('examples')
    if Options.commands['check'] or Options.commands['clean']:
        bld.add_subdirs('tests')

    if Options.commands.get('bench', False) or Options.commands['clean']:
        bld.add_subdirs('benchmarks')


check_context = Build.BuildContext
def bench(bld):
    "run the benchmarks; requires many tools, used by maintainers only"
    Scripting.build(bld)
    env = g_bld.env

    print "Running benchmarks..."
    retval = subprocess.Popen([env['PYTHON'], '-O', 'benchmarks/bench.py',
                               "build/default/benchmarks/results.xml", ' '.join(env['CXXFLAGS_PYEXT'] + env['CXXFLAGS'])]).wait()
    if retval:
        raise SystemExit(retval)

    print "Generating benchmarks report..."
    retval = subprocess.Popen([env['PYTHON'], '-O', 'benchmarks/plotresults.py',
                               "build/default/benchmarks/results.xml",
                               "build/default/benchmarks/results"]).wait()
    if retval:
        raise SystemExit(retval)


check_context = Build.BuildContext
def check(bld):
    "run the unit tests; add option -v for verbose mode"
    Scripting.build(bld)

    if Options.options.verbose:
        verbosity = ['-v']
    else:
        verbosity = []

    if Options.options.valgrind:
        valgrind = ['valgrind', '--leak-check=full', '--leak-resolution=low']
    else:
        valgrind = []

    print "Running pure python unit tests..."
    retval1 = subprocess.Popen([Build.bld.env['PYTHON'], 'tests/test.py'] + verbosity).wait()

    env = g_bld.env

    if env['CXX']:
        print "Running manual module generation unit tests (module foo)..."
        retval2 = subprocess.Popen(valgrind + [env['PYTHON'], 'tests/footest.py', '1'] + verbosity).wait()
    else:
        print "Skipping manual module generation unit tests (no C/C++ compiler)..."
        retval2 = 0

    if env['ENABLE_PYGCCXML']:
        print "Running automatically scanned module generation unit tests (module foo2)..."

=== ns-3.9/samples/wscript ===
## -*- Mode: python; py-indent-offset: 4; indent-tabs-mode: nil; coding: utf-8; -*-

def build(bld):
    env = bld.env_of_name('default')
    if not env['ENABLE_EXAMPLES']:
        return;

    obj = bld.create_ns3_program('main-attribute-value')
    obj.source = 'main-attribute-value.cc'

    obj = bld.create_ns3_program('main-callback')
    obj.source = 'main-callback.cc'

    obj = bld.create_ns3_program('main-simulator')
    obj.source = 'main-simulator.cc'

    obj = bld.create_ns3_program('main-ptr')
    obj.source = 'main-ptr.cc'

    obj = bld.create_ns3_program('main-random-variable')
    obj.source = 'main-random-variable.cc'

    obj = bld.create_ns3_program('main-packet-header', ['common', 'simulator'])
    obj.source = 'main-packet-header.cc'

    obj = bld.create_ns3_program('main-packet-tag', ['common', 'simulator'])
    obj.source = 'main-packet-tag.cc'

    if bld.env['ENABLE_THREADING'] and bld.env["ENABLE_REAL_TIME"]:
        obj = bld.create_ns3_program('main-test-sync')
        obj.source = 'main-test-sync.cc'

    obj = bld.create_ns3_program('main-simple',
                                 ['node', 'internet-stack', 'onoff'])
    obj.source = 'main-simple.cc'

    obj = bld.create_ns3_program('main-grid-topology',
                                 ['core', 'simulator', 'mobility', 'internet-stack'])
    obj.source = 'main-grid-topology.cc'

    obj = bld.create_ns3_program('main-random-topology',
                                 ['core', 'simulator', 'mobility'])
    obj.source = 'main-random-topology.cc'
    
    obj = bld.create_ns3_program('main-random-walk',
                                 ['core', 'simulator', 'mobility'])
    obj.source = 'main-random-walk.cc'

    obj = bld.create_ns3_program('main-propagation-loss',
                                 ['core', 'simulator', 'mobility', 'wifi'])
    obj.source = 'main-propagation-loss.cc'

    obj = bld.create_ns3_program('sample-random-variable',
                                 ['core', 'simulator'])
    obj.source = 'sample-random-variable.cc'

=== pybindgen-0.15.0/examples/wscript ===
## -*- python -*-

def build(bld):
    bld.add_subdirs('a b c d e f g h')
    bld.add_subdirs('callback')

=== ns-3.9/examples/animation/wscript ===
## -*- Mode: python; py-indent-offset: 4; indent-tabs-mode: nil; coding: utf-8; -*-

def build(bld):
    obj = bld.create_ns3_program('dumbbell-animation',
                                 ['point-to-point', 'internet-stack'])
    obj.source = 'dumbbell-animation.cc'

    obj = bld.create_ns3_program('grid-animation',
                                 ['point-to-point', 'internet-stack'])
    obj.source = 'grid-animation.cc'

    obj = bld.create_ns3_program('star-animation',
                                 ['point-to-point', 'internet-stack'])
    obj.source = 'star-animation.cc'

=== ns-3.9/examples/csma/wscript ===
## -*- Mode: python; py-indent-offset: 4; indent-tabs-mode: nil; coding: utf-8; -*-

def build(bld):
    obj = bld.create_ns3_program('csma-one-subnet', ['csma', 'internet-stack'])
    obj.source = 'csma-one-subnet.cc'

    obj = bld.create_ns3_program('csma-bridge', ['bridge', 'csma', 'internet-stack'])
    obj.source = 'csma-bridge.cc'

    obj = bld.create_ns3_program('csma-bridge-one-hop', ['bridge', 'csma', 'internet-stack'])
    obj.source = 'csma-bridge-one-hop.cc'

    obj = bld.create_ns3_program('csma-broadcast', ['csma', 'internet-stack'])
    obj.source = 'csma-broadcast.cc'

    obj = bld.create_ns3_program('csma-packet-socket', ['csma', 'internet-stack'])
    obj.source = 'csma-packet-socket.cc'

    obj = bld.create_ns3_program('csma-multicast', ['csma', 'internet-stack'])
    obj.source = 'csma-multicast.cc'

    obj = bld.create_ns3_program('csma-star', ['csma', 'internet-stack'])
    obj.source = 'csma-star.cc'

    obj = bld.create_ns3_program('csma-raw-ip-socket', ['csma', 'internet-stack'])
    obj.source = 'csma-raw-ip-socket.cc'

    obj = bld.create_ns3_program('csma-ping', ['csma', 'internet-stack', 'v4ping'])
    obj.source = 'csma-ping.cc'

=== ns-3.9/examples/emulation/wscript ===
## -*- Mode: python; py-indent-offset: 4; indent-tabs-mode: nil; coding: utf-8; -*-

def build(bld):
    env = bld.env_of_name('default')
    if env['ENABLE_EMU']:
        obj = bld.create_ns3_program('emu-udp-echo', ['emu', 'internet-stack'])
        obj.source = 'emu-udp-echo.cc'

        obj = bld.create_ns3_program('emu-ping', ['emu', 'internet-stack'])
        obj.source = 'emu-ping.cc'

=== ns-3.9/examples/flowmon/wscript ===
## -*- Mode: python; py-indent-offset: 4; indent-tabs-mode: nil; coding: utf-8; -*-

def build(bld):
    pass

=== ns-3.9/examples/mpi/wscript ===
## -*- Mode: python; py-indent-offset: 4; indent-tabs-mode: nil; coding: utf-8; -*-

def build(bld):
    obj = bld.create_ns3_program('simple-distributed',
                                 ['point-to-point', 'internet-stack'])
    obj.source = 'simple-distributed.cc'

    obj = bld.create_ns3_program('third-distributed',
                                 ['point-to-point', 'internet-stack'])
    obj.source = 'third-distributed.cc'

    obj = bld.create_ns3_program('nms-udp-nix',
                                 ['point-to-point', 'internet-stack'])
    obj.source = 'nms-udp-nix.cc'

=== ns-3.9/examples/naming/wscript ===
## -*- Mode: python; py-indent-offset: 4; indent-tabs-mode: nil; coding: utf-8; -*-

def build(bld):
    obj = bld.create_ns3_program('object-names', ['core', 'simulator', 'csma', 'internet-stack'])
    obj.source = 'object-names.cc'

=== ns-3.9/examples/routing/wscript ===
## -*- Mode: python; py-indent-offset: 4; indent-tabs-mode: nil; coding: utf-8; -*-

def build(bld):
    obj = bld.create_ns3_program('dynamic-global-routing',
                                 ['point-to-point', 'csma', 'internet-stack', 'global-routing'])
    obj.source = 'dynamic-global-routing.cc'

    obj = bld.create_ns3_program('static-routing-slash32',
                                 ['point-to-point', 'internet-stack', 'global-routing'])
    obj.source = 'static-routing-slash32.cc'

    obj = bld.create_ns3_program('global-routing-slash32',
                                 ['point-to-point', 'internet-stack', 'global-routing'])
    obj.source = 'global-routing-slash32.cc'

    obj = bld.create_ns3_program('global-injection-slash32',
                                 ['point-to-point', 'internet-stack', 'global-routing'])
    obj.source = 'global-injection-slash32.cc'

    obj = bld.create_ns3_program('simple-global-routing',
                                 ['point-to-point', 'internet-stack', 'global-routing'])
    obj.source = 'simple-global-routing.cc'

    obj = bld.create_ns3_program('simple-alternate-routing',
                                 ['point-to-point', 'internet-stack', 'global-routing'])
    obj.source = 'simple-alternate-routing.cc'

    obj = bld.create_ns3_program( 'mixed-global-routing',
                                  ['point-to-point', 'internet-stack', 'global-routing' , 'csma-cd'])
    obj.source = 'mixed-global-routing.cc'

    obj = bld.create_ns3_program('simple-point-to-point-olsr',
                                 ['point-to-point', 'internet-stack', 'olsr'])
    obj.source = 'simple-point-to-point-olsr.cc'

    obj = bld.create_ns3_program('olsr-hna',
                                 ['core', 'simulator', 'mobility', 'wifi'])
    obj.source = 'olsr-hna.cc'

    obj = bld.create_ns3_program('nix-simple',
                                 ['point-to-point', 'internet-stack', 'nix-vector-routing'])
    obj.source = 'nix-simple.cc'

    obj = bld.create_ns3_program('nms-p2p-nix',
                                 ['point-to-point', 'internet-stack', 'nix-vector-routing'])
    obj.source = 'nms-p2p-nix.cc'

    obj = bld.create_ns3_program('simple-routing-ping6',
      ['csma', 'internet-stack'])
    obj.source = 'simple-routing-ping6.cc'
    
    obj = bld.create_ns3_program('aodv',
                                 ['wifi', 'internet-stack', 'aodv'])
    obj.source = 'aodv.cc'

=== ns-3.9/examples/spectrum/wscript ===
## -*- Mode: python; py-indent-offset: 4; indent-tabs-mode: nil; coding: utf-8; -*-

def build(bld):
    obj = bld.create_ns3_program('adhoc-aloha-ideal-phy',
                                 ['spectrum'])
    obj.source = 'adhoc-aloha-ideal-phy.cc'

    obj = bld.create_ns3_program('adhoc-aloha-ideal-phy-with-microwave-oven',
                                 ['spectrum'])
    obj.source = 'adhoc-aloha-ideal-phy-with-microwave-oven.cc'

=== debian/changelog ===
ns3 (3.9-1build1) natty; urgency=low

  * Rebuild to add support for python 2.7.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 03 Dec 2010 00:05:43 +0000

ns3 (3.9-1) unstable; urgency=low

  * fix dep of libns3-dev,add libns3-3
  * add Build-Conflicts: libmpich2-dev
  * modify descripts (Closes: #579311)
  * fix virtual-network-setup.sh bashism (Closes: #581476)
  * port to Debian Policy 3.9.0

 -- YunQiang Su <wzssyqa@gmail.com>  Sat, 21 Aug 2010 14:15:10 +0800

=== debian/control ===
Source: ns3
Section: net
Priority: optional
Standards-Version: 3.9.1
Maintainer: YunQiang Su <wzssyqa@gmail.com>
Build-Depends: debhelper (>= 7.0.50~), quilt (>= 0.46-7~), pkg-config, python-all-dev, python-support,
		texi2html, dia, doxygen, graphviz, imagemagick, 
		libxml2-dev, libgsl0-dev, libsqlite3-dev,
		flex, bison, 
		libopenmpi-dev [alpha amd64 hurd-i386 i386 ia64 kfreebsd-amd64 kfreebsd-i386 powerpc sparc]
Build-Conflicts: libmpich2-dev
Vcs-git: git://github.com/wzssyqa/ns3-debian.git
Vcs-Browser: http://github.com/wzssyqa/ns3-debian
Homepage: http://www.nsnam.org/

Package: ns3
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: discrete-event network simulator for Internet systems
 ns-3 is a discrete-event network simulator for Internet systems, 
 targeted primarily for research and educational use. 
 ns-3 is free software, licensed under the GNU GPLv2 license, 
 and is publicly available for research, development, and use.
 ns-3 is intended as an eventual replacement for the popular
 ns-2 simulator. The project acronym “nsnam” derives 
 historically from the concatenation of ns (network simulator) 
 and nam (network animator). 

Package: ns3-doc
Architecture: all
Depends: ${misc:Depends}
Section: doc
Description: documentation for ns3
 ns-3 is a discrete-event network simulator for Internet systems, 
 targeted primarily for research and educational use. 
 ns-3 is free software, licensed under the GNU GPLv2 license, 
 and is publicly available for research, development, and use. 
 ns-3 is intended as an eventual replacement for the popular
 ns-2 simulator. The project acronym “nsnam” derives 
 historically from the concatenation of ns (network simulator) 
 and nam (network animator). 
 .
 This package contains manual, testing, tutorial.

Package: libns3-3
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: shared library files of ns3
 ns-3 is a discrete-event network simulator for Internet systems, 
 targeted primarily for research and educational use. 
 ns-3 is free software, licensed under the GNU GPLv2 license, 
 and is publicly available for research, development, and use. 
 ns-3 is intended as an eventual replacement for the popular
 ns-2 simulator. The project acronym “nsnam” derives 
 historically from the concatenation of ns (network simulator) 
 and nam (network animator). 
 .
 This package contains shared library files.

Package: libns3-dev
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libns3-3 (= ${binary:Version})
Section: libdevel
Suggests: valgrind, gdb, libgoocanvas-dev, tcpdump
Description: develop files of ns3
 ns-3 is a discrete-event network simulator for Internet systems, 
 targeted primarily for research and educational use. 
 ns-3 is free software, licensed under the GNU GPLv2 license, 
 and is publicly available for research, development, and use. 
 ns-3 is intended as an eventual replacement for the popular
 ns-2 simulator. The project acronym “nsnam” derives 
 historically from the concatenation of ns (network simulator) 
 and nam (network animator). 
 .
 This package contains development files.

Package: python-ns3
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ${python:Depends}
Section: python
Suggests: python-pygraphviz, python-kiwi, python-pygoocanvas, tcpdump
Description: Python binding of ns3
 ns-3 is a discrete-event network simulator for Internet systems, 
 targeted primarily for research and educational use. 
 ns-3 is free software, licensed under the GNU GPLv2 license, 
 and is publicly available for research, development, and use. 
 ns-3 is intended as an eventual replacement for the popular
 ns-2 simulator. The project acronym “nsnam” derives 
 historically from the concatenation of ns (network simulator) 
 and nam (network animator). 
 .
 This package contains Python binding of ns3.

=== debian/rules ===
#!/usr/bin/make -f

NS3VER=3.9
NS3_DIR=ns-$(NS3VER)
PYBINDGENV_DIR=pybindgen-0.15.0
REFTRACE_DIR=ns-$(NS3VER)-ref-traces
NSC_DIR=nsc-0.5.2

RELEASE=debug

PYVERS=$(shell pyversions -s)

%:
	dh $@ --with quilt


override_dh_auto_configure:
#	cd $(NS3_DIR);./waf configure --disable-examples -d $(RELEASE) \
#		--prefix=/usr --with-regression-traces=../$(REFTRACE_DIR) \
#		--with-pybindgen=../$(PYBINDGENV_DIR) --with-nsc=../$(NSC_DIR) \
#		--enable-mpi --python-scan --enable-python-pch --doxygen-no-build
	cp ./debian/build.config ./.config


override_dh_auto_build:
	cp debian/doc-makefile/makefile-manual ./$(NS3_DIR)/doc/manual/GNUmakefile
	make manual/manual.html -C ./$(NS3_DIR)/doc/manual/
	cp debian/doc-makefile/makefile-testing ./$(NS3_DIR)/doc/testing/GNUmakefile
	make testing/testing.html -C ./$(NS3_DIR)/doc/testing/
	cp debian/doc-makefile/makefile-tutorial ./$(NS3_DIR)/doc/tutorial/GNUmakefile
	make split-html -C ./$(NS3_DIR)/doc/tutorial/

#	cd $(NS3_DIR);./waf build
	./build.py
	
	cd $(NS3_DIR); ./waf --doxygen
	

override_dh_auto_test:
	cd ./$(NS3_DIR); ./test.py

override_dh_auto_install:
	################################################ ns3
	cd ./$(NS3_DIR);./waf install --destdir=../debian/ns3
	if [ ! -d ./debian/ns3/usr/share/doc/ns3 ] ;then mkdir -p ./debian/ns3/usr/share/doc/ns3 ;fi
	cp ./$(NS3_DIR)/RELEASE_NOTES ./debian/ns3/usr/share/doc/ns3
	cp ./$(NS3_DIR)/README ./debian/README.source

	################################################ libns3-3
	mkdir -p ./debian/libns3-3/usr/lib
	mv ./debian/ns3/usr/lib/libns3.so.3 ./debian/libns3-3/usr/lib
	mv ./debian/ns3/usr/lib/libns3.so.$(NS3VER) ./debian/libns3-3/usr/lib

	################################################ ns3-doc	
#	mkdir -p ./debian/tmp/ns3-doc
#	
#	cp ./$(NS3_DIR)/doc/manual/manual.pdf ./$(NS3_DIR)/doc/manual/manual.html ./debian/tmp/ns3-doc
#	cp -r ./$(NS3_DIR)/doc/manual/manual ./debian/tmp/ns3-doc

#	
#	cp  ./$(NS3_DIR)/doc/testing/testing.pdf ./$(NS3_DIR)/doc/testing/testing.html ./debian/tmp/ns3-doc
#	cp -r ./$(NS3_DIR)/doc/testing/testing ./debian/tmp/ns3-doc

#	cp ./$(NS3_DIR)/doc/tutorial/tutorial.pdf ./$(NS3_DIR)/doc/tutorial/tutorial.html ./debian/tmp/ns3-doc
#	cp -r ./$(NS3_DIR)/doc/tutorial/tutorial ./debian/tmp/ns3-doc
#	cp ./$(NS3_DIR)/doc/build.txt ./$(NS3_DIR)/doc/codingstd.txt ./$(NS3_DIR)/doc/contributing.txt ./$(NS3_DIR)/doc/mercurial.txt ./$(NS3_DIR)/doc/modules ./$(NS3_DIR)/doc/release_steps.txt ./debian/tmp/ns3-doc
#	################################################ libns3-dev
	mkdir -p ./debian/tmp/libns3-dev/	
	cp -r ./$(NS3_DIR)/build/$(RELEASE)/ns3 ./debian/tmp/libns3-dev/
	find ./$(NS3_DIR)/build/$(RELEASE)/src -name '*.o' -exec cp -n {} ./debian/tmp/libns3-dev/ \;
	ar r debian/tmp/libns3-dev/libns3.a debian/tmp/libns3-dev/*.o
	ranlib debian/tmp/libns3-dev/libns3.a
	mv ./debian/ns3/usr/lib/libns3.so debian/tmp/libns3-dev/
	cp -r $(NS3_DIR)/examples debian/tmp/libns3-dev/
	find debian/tmp/libns3-dev/examples -name 'waf' -exec rm {} \;
	############################################### python-ns3
#	python ./debian/python-ns3-setup.py install --prefix=./debian/python-ns3/usr

	for pyv in $(PYVERS);\
	do \
		mkdir -p ./debian/python-ns3/usr/lib/$${pyv}/dist-packages/ ;\
		cp -r $(NS3_DIR)/build/debug/bindings/python/ns3 ./debian/python-ns3/usr/lib/$${pyv}/dist-packages/ ;\
	done
	############################################### other clean
	rm -rf ./debian/ns3/usr/lib/
	
	dh_install

override_dh_installchangelogs:
	dh_installchangelogs ./$(NS3_DIR)/CHANGES.html

override_dh_auto_clean:
	sh ./debian/clean-tree.sh
